//
// toolbars.C  last changed Aug. 29, 1994
// Testing toolbars.
// This application should run under Motif and Xaw
//
// It will run under TIP when subpanes and toolbar support
// has been added to the TIP implementation (probably mid 1995)
//
// This program does nothing useful at all. It was written
// for testing the automatical layout of the XmWindow class.
// 

#include <iostream.h>
#include <stdlib.h>
#include <xmObject.h>

class TestWindow : public XmWindow
{
	bool initWindowSize(int&, int&, int& w, int& h)		{ w = 500; h = 400; return(TRUE); }
public:
	TestWindow();

	void initialize();

	void myMenuItem(char*);
	void myPushButton(void*);
	void testToolbars(char*);

	void openNext(void*);
	void close(void*);

	void quit(void*);
};


void XmApp::initialize()
{
	(new TestWindow)->open();
};

typedef void (*procptr)();


TestWindow::TestWindow() : XmWindow("Test")
{
}

void TestWindow::initialize()
{
	XmDropdownMenu* m = createDropdownMenu();

	m->addLabels("&File", "&Edit", "&Misc", "&Test", NULL);

	m->setCurrentLabel("File");
	m->addItems(
	  Entry("&Open", (XmObject* )NULL, CBK(TestWindow, openNext)),
	  Entry("&Close", (XmObject* )NULL, CBK(TestWindow, close)),
	  NULLENTRY);
	m->addSeparator();
	m->addItems(
	  Entry("E&xit", (XmObject* )NULL, CBK(TestWindow, quit)),
	  NULLENTRY);
	m->setCurrentLabel("Misc");
	m->addItems(
	  Entry("&Everything", (XmObject* )NULL, CBK(TestWindow, myMenuItem)),
	  Entry("&Hello", (XmObject* )NULL, CBK(TestWindow, myMenuItem)),
	  NULLENTRY);
	m->setCurrentLabel("Test");
	m->addItems(
	  Entry("&lBar", (XmObject* )NULL, CBK(TestWindow, testToolbars)),
	  Entry("&rBar", (XmObject* )NULL, CBK(TestWindow, testToolbars)),
	  Entry("&tBar", (XmObject* )NULL, CBK(TestWindow, testToolbars)),
	  Entry("&bBar", (XmObject* )NULL, CBK(TestWindow, testToolbars)),
	  Entry("&statusBar", (XmObject* )NULL, CBK(TestWindow, testToolbars)),
	  NULLENTRY);

	addSubpane(Edit, "TestEdit");	// , "My Test Edit");

	XmToolBar* tb;

	tb = addToolbar(XmSleft);
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon1.gif"))), this, CBK(TestWindow, myPushButton));
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon2.gif"))), this, CBK(TestWindow, myPushButton));
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon3.gif"))), this, CBK(TestWindow, myPushButton));
	tb = addToolbar(XmSright);
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon1.gif"))), this, CBK(TestWindow, myPushButton));
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon2.gif"))), this, CBK(TestWindow, myPushButton));
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon3.gif"))), this, CBK(TestWindow, myPushButton));
	tb = addToolbar(XmStop);
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon1.gif"))), this, CBK(TestWindow, myPushButton));
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon2.gif"))), this, CBK(TestWindow, myPushButton));
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon3.gif"))), this, CBK(TestWindow, myPushButton));
	tb = addToolbar(XmSbottom);
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon1.gif"))), this, CBK(TestWindow, myPushButton));
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon2.gif"))), this, CBK(TestWindow, myPushButton));
	tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon3.gif"))), this, CBK(TestWindow, myPushButton));
/*
	XmStatusBar* stb = createStatusBar();
	stb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon4.gif"))), this, CBK(TestWindow, myPushButton));
	stb->setMessage("idle...");
*/
}

void TestWindow::myMenuItem(char* n)
{
	cerr << "menu item: " << n << " selected.\n";
}

void TestWindow::myPushButton(void*)
{
	cerr << "button pressed...\n";
}

void TestWindow::testToolbars(char* n)
{
	cerr << "testing: " << n << " .\n";

	xmStyle which = 0;

	switch(*n)
	{	case 'l':
		which = XmSleft;
		break;
		case 'r':
		which = XmSright;
		break;
		case 't':
		which = XmStop;
		break;
		case 'b':
		which = XmSbottom;
		break;
	}
	if(which)
	{	XmToolBar* tb;
		if(tb = toolbar(which))
		{	removeToolbar(tb);
			delete tb;
		}
		else
		{	tb = addToolbar(which);
			tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon1.gif"))), this, CBK(TestWindow, myMenuItem), CB_OBJ_NAME);
			tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon2.gif"))), this, CBK(TestWindow, myPushButton));
			tb->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon3.gif"))), this, CBK(TestWindow, myPushButton));
		}
	}
/*
	else
	{	if(!getStatusBar()->remove("&Push"))
			getStatusBar()->add(((new XmPushButton("&Push"))->setImage(getRuntimeImage("icon4.gif"))), this, CBK(TestWindow, myPushButton));
	}
*/
}


void TestWindow::openNext(void*)
{
	(new TestWindow)->open();
}

void TestWindow::close(void*)
{
	destroyOnDelete();
	delete this;
}

void TestWindow::quit(void*)
{
	App->quit();
}





